#pragma once

#include "thread.hpp"

class Connection;

struct IrcMsgEvent : Event
{
    IrcMsgEvent(IrcMsg irc) : irc{irc} {}
    IrcMsg irc;
};

struct IrcParseThread : Thread
{
    Connection * connection_;

    IrcParseThread(Connection * connection) noexcept;
    auto priority() const -> priority_type override;
    auto on_event(Event const& event) -> callback_result override;
};