#pragma once

#include "connection.hpp"
#include "thread.hpp"

class PingThread : public Thread
{
    Connection * connection_;

public:
    PingThread(Connection * connection) noexcept;

    auto priority() const -> priority_type override;
    auto on_event(Event const& event) -> std::pair<ThreadOutcome, EventOutcome> override;
};
